/**
 * Diese Klasse definiert Zhler fr die Akteurstypen
 * in einer Simulation.
 * Ein Zhler wird ber einen Namen identifiziert und 
 * zhlt, wieviele Akteure des Typs innerhalb der Simulation
 * jeweils existieren.
 * 
 * @author David J. Barnes und Michael Klling
 * @version 2006.03.30
 */
public class Zaehler
{
    // Ein Name fr den Akteurstyp in dieser Simulation
    private String name;
    // Wie viele von diesem Typ existieren in der Simulation.
    private int zaehler;

    /**
     * Initialisiere mit dem Namen des Typs.
     * @param name Ein Name, z.B. "Fuchs".
     */
    public Zaehler(String name)
    {
        this.name = name;
        zaehler = 0;
    }
    
    /**
     * @return den Namen des Typs dieses Zhlers.
     */
    public String gibName()
    {
        return name;
    }

    /**
     * @return den aktuellen Zhlerstand dieses Typs.
     */
    public int gibStand()
    {
        return zaehler;
    }

    /**
     * Erhhe diesen Zhler um Eins.
     */
    public void erhoehen()
    {
        zaehler++;
    }
    
    /**
     * Setze diesen Zhler auf Null zurck.
     */
    public void zuruecksetzen()
    {
        zaehler = 0;
    }
}
